import java.util.Vector;
import java.awt.*;
import java.awt.geom.*;
import javax.swing.*;
import java.io.*;
import java.net.*;
import java.awt.Color;
import H.*;

class ER1 implements Updatable, Drawable
{
    public static final int REMOTE_CONTROL = 0;
    public static final int WANDER = 1;
    public static final int TURNAROUND = 2;
    public static final int DOTURN = 3;
    public static final int BACKUP = 4;
    public static int WANDER_STATE = ER1.REMOTE_CONTROL;
    
    public static double IR_NW_TH;
    public static double IR_N_TH;
    public static double IR_NE_TH;
    
    public static double goalAngle = 0.0;
    public static double nextVRot = 0.0;
    public static int stateTick = 0;
    
    public static int IN_PROGRAM = 0;
	public static final int SIMULATED = 0;
	public static final int REALROBOT = 1;
	
	public static final int FORWARD = 2;
	public static final int BACKWARD = 3;
	public static final int LEFT = 4;
	public static final int RIGHT = 5;
	public static final int ALL_DIRS = 6;
	
	public int sensorDisplay = SD_NONE;
	public static final int SD_NONE = 0; // SD stands for Sensor Display
	public static final int SD_IR = 1;
	public static final int SD_CAM = 2;
	public static final int SD_IR_CAM = 3;
	public static final int SD_MAX = 4; // make this one more than the biggest
	
	public static int simulationStatus;
	public Pose lastUpdatedPose;
	public double x; public static double x_init;
	public double y; public static double y_init;
	public double theta; public static double theta_init;
	public double time;
	
	public double ir_nw;
	public double ir_n;
	public double ir_ne;
	
	public double wi;
	public static File file = new File("R:/signal_strength.txt");
	FileReader fstream;
	
	public double vTrans,vTransOld;  // translational velocity
    public double vRot,vRotOld;    // rotational velocity
	
	public AffineTransform savedAT;
	public AffineTransform AT;
	public MyPoly er1poly;  // Drawable for display
	
	public PFilter pfilter;
	public static int filterSize;
	
	Socket MyClient = null;
	BufferedReader input = null;
	PrintStream output = null;
	
	public static BufferedReader configFile;
	public static boolean ALL_SAME = false;
    public static boolean ALL_SAME_DIR = false;
	
	public int updateCounter = 0;
	public static int updateInterval;
	
	public static void configure()
	{
        simulationStatus = ER1.SIMULATED;
        try 
        {
            configFile = new BufferedReader(new FileReader("config.txt"));
            String[] L;
            
            String line = configFile.readLine();
            if (line == null) filterSize = 500; // 500 default particles
            else {
                L = line.trim().split("\\s+");
                filterSize = Integer.parseInt(L[0]);
            }
            H.pl("Using " + filterSize + " particles");
            
            line = configFile.readLine();
            if (line == null) ALL_SAME = ALL_SAME_DIR = false;
            else {
                L = line.trim().split("\\s+");
                ALL_SAME = (1 == Integer.parseInt(L[0]));
                ALL_SAME_DIR = (1 == Integer.parseInt(L[1]));
            }
            H.pl("ALL_SAME, ALL_SAME_DIR " + ALL_SAME + " " + ALL_SAME_DIR);
            
            line = configFile.readLine();
            if (line == null) updateInterval = 50; // 50 loops == 5 seconds
            else {
                L = line.trim().split("\\s+");
                updateInterval = Integer.parseInt(L[0]);
            }
            H.pl("Using an updateInterval of " + updateInterval);
            
            line = configFile.readLine();
            if (line == null) PFilter.JITTER = 3; // 3 degrees
            else {
                L = line.trim().split("\\s+");
                PFilter.JITTER = Double.parseDouble(L[0]);
            }
            H.pl("Using jitter of " + PFilter.JITTER);
            
            line = configFile.readLine();
            if (line == null) PFilter.TRANS_ERR_WIDTH = .2; // 20% translational error
            else {
                L = line.trim().split("\\s+");
                PFilter.TRANS_ERR_WIDTH = Double.parseDouble(L[0]);
            }
            H.pl("Using an error width of " + PFilter.TRANS_ERR_WIDTH);
            
            line = configFile.readLine();
            if (line == null) PFilter.ROTERR_WIDTH = .2; // rotational
            else {
                L = line.trim().split("\\s+");
                PFilter.ROTERR_WIDTH = Double.parseDouble(L[0]);
            }
            H.pl("Using an rot. error width of " + PFilter.ROTERR_WIDTH);
            
            line = configFile.readLine();
            if (line == null) x_init = y_init = theta_init = 0.0; // starting point
            else {
                L = line.trim().split("\\s+");
                x_init =  Double.parseDouble(L[0]);
                y_init =  Double.parseDouble(L[1]);
                theta_init =  Double.parseDouble(L[2]);
            }
            H.pl("Using x,y,theta of " + x_init + " " + y_init + " " + theta_init);
            
            line = configFile.readLine();
            double a = 0.0,b = 0.0, c = 1.0; // MAP_OFFSET_X _Y and MAP_SCALE
            if (line == null) ;      // starting point
            else {
                L = line.trim().split("\\s+");
                a =  Double.parseDouble(L[0]);
                b =  Double.parseDouble(L[1]);
                c =  Double.parseDouble(L[2]);
            }
            H.pl("Using MAP_OFFSET_X _Y and MAP_SCALE of " + a + " " + b + " " + c);
            EnvMap.MAP_OFFSET_X = a;
            EnvMap.MAP_OFFSET_Y = b;
            EnvMap.MAP_SCALE = c;
            
            line = configFile.readLine();//IR_NW_TH, _N_, _NE_
            if (line == null) ;      // starting point
            else {
                L = line.trim().split("\\s+");
                a =  Double.parseDouble(L[0]);
                b =  Double.parseDouble(L[1]);
                c =  Double.parseDouble(L[2]);
            }
            H.pl("Using IR_NW_TH, _N_, _NE_ of " + a + " " + b + " " + c);
            ER1.IR_NW_TH = a;
            ER1.IR_N_TH = b;
            ER1.IR_NE_TH = c;
            
            configFile.close();
        } // end try block 
        catch (Exception e) 
        {
           e.printStackTrace();
        }
	   
	}
	
    public ER1()
	{
	    ER1.WANDER_STATE = ER1.REMOTE_CONTROL;
		this.simulationStatus = ER1.SIMULATED;
		H.pl("Hi there fromER1()");
   	    init(filterSize);	// make the connection, etc.
	}
	
	public void init(int pfilter_size)
	{
		pfilter = new PFilter(pfilter_size);
		AT = new AffineTransform();
		vTrans = 0.0;  // scale from 0-100
		vRot = 0.0;    // scale from 0-100
		vTransOld = 0.0;  // scale from 0-100
		vRotOld = 0.0;    // scale from 0-100
		
		x = x_init;
		y = y_init;
		theta = theta_init;
		
		time = 0;
		er1poly = new MyPoly();
        simulationStatus = SIMULATED;
		
		if (realRobot())
		{
			setUpConnection();
		}
	}
	
	public String getGoString(int direction)
	{
		
		if (vTrans > 100)  vTrans = 100.0;
		if (vTrans < -100)  vTrans = -100.0;
		
		if (vTrans < 0.001 && vTrans >= 0.0)  vTrans = 0.0; // avoid exp. notation
		if (vTrans > -0.001 && vTrans <= 0.0)  vTrans = 0.0; // avoid exp. notation
		
		if (vRot > 100)  vRot = 100.0;
		if (vRot < -100)  vRot = -100.0;
		
		if (vRot < 0.1 && vRot >= 0.0) vRot = 0.0;
		if (vRot > -0.1 && vRot <= 0.0) vRot = 0.0;
		
		
		switch (direction)
		{
			case ER1.ALL_DIRS:
				return "v," + vTrans + "," + (vRot/100.0);
			case ER1.FORWARD:
				return "v," + vTrans + ",0";
			case ER1.BACKWARD:
				return "v," + (-vTrans) + ",0";
			case ER1.LEFT:
				return "v,0," + (vRot/100.0);
			case ER1.RIGHT:
				return "v,0," + (-vRot/100.0);
			default:
			    H.pl("Unexpected direction in getGoString: " + direction);
				return "v,0,0";	 // stop as a default
		}
	}
	
	public void shutDown()
	{
		if (this.realRobot())
		{
			try
			{
				if (output != null) output.close();      // clean up socket stuff
				H.pl("output stream is closed");
				if (input != null) input.close();
				H.pl("input stream is closed");
				if (MyClient != null) MyClient.close();
				H.pl("socket client is closed");
				fstream.close();
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}	
		}
		H.pl("Robot is now simulated");
		simulationStatus = ER1.SIMULATED;	
	}
	
	public void setUpConnection()
	{
		// connect to server... if it fails, print a warning and then
		// go to simulated robot...
		try
		{
			//MyClient = new Socket("134.173.42.86", 5001); // desktop
			//MyClient = new Socket("127.0.0.1", 5001); // loopback
			MyClient = new Socket("134.173.200.58", 5001); // wired laptop
            //MyClient = new Socket("192.168.0.1", 5001); // ad hoc laptop
   			input = new BufferedReader(new InputStreamReader(MyClient.getInputStream()));
   			output = new PrintStream(MyClient.getOutputStream());
   			/*
   			String s;
   			while (true)
			{
				H.p("What string would you like to send?  ");
				s = H.nl();
				if (s.equals("quit"))  // "quit" gets out w/o stopping the server
				{
					break; // break out of the while loop
				}
				output.print(s);    // don't use println: it messes with the server			
				H.pl("We sent the string   " + s);
				s = input.readLine();
				if (s == null) continue;  // no line of text available
				H.pl("The string returned from the server was    " + s);
			}
			*/
			simulationStatus = ER1.REALROBOT;
			// reset velocities
			vTrans = vRot = 0.0;
			CS5App.cpanel.vTrans.setText(""+(float)vTrans);
    		CS5App.cpanel.vRot.setText(""+(float)vRot); 
    		H.pl("realRobot() is now " + realRobot());
   		}
   		catch (Exception e)
		{
			e.printStackTrace();
			this.shutDown(); // sets to simulated
		}	
	}
	
	public boolean checkForValidInputString(String s)
	{
		return true; // for future expansion...
	}
	
	public String exchangeWithServer(String s)
	{
		if (!realRobot())
		{
			return "simulated robot";
		}
		
		// send s and receive information back...
	   	String returnString = "invalid input string: " + s;
	   	
	   	if (checkForValidInputString(s))
	   	{
	   		try
	   		{
		   		output.print(s);    // don't use println: it messes with the server
		   		if (!s.equals("A")) H.pl("Sending   " + s);
		   		returnString = input.readLine();
		   		//H.pl("\"" + returnString + "\" was returned");
		   	}
		   	catch (Exception e)
		   	{
		   		H.pl("Exception caught in exchangeWithServer");
		   		e.printStackTrace();
		   		this.shutDown();
				returnString = "error with input string " + s;
		   	}
		   			
	   	}
	   	
	   	return returnString;
	}
	
	public static double angleDiff(double deg1, double deg2)
	{
	   // first, get deg1 > 0
	   while (deg1<0) deg1 += 360;
	   // next, get deg2 > 0
	   while (deg2<0) deg2 += 360;
	   // next, get both <= 360
	   while (deg1 >= 360) deg1 -= 360;
       while (deg2 >= 360) deg2 -= 360;
	   // see which one's bigger
	   if (deg1 < deg2)
	   {
	       return Math.min(deg2-deg1,360-deg2+deg1);
	   }
	   else
	   {
           return Math.min(deg1-deg2,360-deg1+deg2);
	   }
	}
	
	public void doPath(int i)
	{
	   // this either takes the sensor
	   // values and decides what to do with them
	   // or it just runs some opn-loop
	   // path segments
	   if (ER1.WANDER_STATE == ER1.REMOTE_CONTROL)
	   {
	       // H.pl("Remote Control");
	       // maintain whatever velocity we have
	   }
       else if (ER1.WANDER_STATE == ER1.WANDER)
       {
           // maintain whatever velocity we have,
           // except that if any ir gets too low,
           // we avoid whatever it is...
           // we do this by stopping, turning an
           // appropriate amount in an appropriate direction
           // and then continuing
           
           H.pl("Wander state");
           // first, check N
           if (ir_n < IR_N_TH)
           {
               vRot = 0; vTrans = 0;
               ER1.WANDER_STATE = ER1.BACKUP;
               double randomAngleDelta = 10*(2*Math.random()-1);
               ER1.goalAngle = theta < 0 ? theta + 180 : theta - 180;
               ER1.goalAngle += randomAngleDelta;
               ER1.nextVRot = theta < 0 ? 20 : -20;
               ER1.stateTick = 0;
               if (realRobot())
               {

					double dx = -CS5App.envMap.MAP_OFFSET_X + x + Math.cos(-theta) * ir_n;
               		double dy = -CS5App.envMap.MAP_OFFSET_Y + y + Math.sin(-theta) * ir_n;
               		Line2D.Double l = CS5App.envMap.makeWall(dx, dy, dx + 5, dy + 5);
               		//CS5App.envMap.addWall(l);
               }
               updateParticles();
               return;
           }
           
           // next,check left AND right
           if (ir_nw < IR_NW_TH && ir_ne < IR_NE_TH)
           {
               vRot = 0; vTrans = 0;
               ER1.WANDER_STATE = ER1.BACKUP;
               double randomAngleDelta = 10*(2*Math.random()-1);
               ER1.goalAngle = theta < 0 ? theta + 180 : theta - 180;
               ER1.goalAngle += randomAngleDelta;
               ER1.nextVRot = theta < 0 ? 20 : -20;
               ER1.stateTick = 0;
               updateParticles(); 
               return;          
           }
           
           // next, check just left
           if (ir_nw < IR_NW_TH)
           {
               vRot = 0; vTrans = 0;
               ER1.WANDER_STATE = ER1.BACKUP;
               double randomAngleDelta = 10*(2*Math.random()-1);
               ER1.goalAngle = theta + 90;
               ER1.goalAngle += randomAngleDelta;
               ER1.nextVRot = 20;
               if (realRobot())
               {
               		ER1.nextVRot = -20;
               		double dx = -CS5App.envMap.MAP_OFFSET_X + x + Math.cos(-theta - .52) * ir_nw;
               		double dy = -CS5App.envMap.MAP_OFFSET_Y + y + Math.sin(-theta - .52) * ir_nw;
               		H.pl("x: " + x + "y: " + y + "dx: " + dx + "dy: " + dy);
               		Line2D.Double l = CS5App.envMap.makeWall(dx, dy, dx + 5, dy + 5);
               		//CS5App.envMap.addWall(l);
               }
               ER1.stateTick = 0; 
               updateParticles();
               return;          
           }
           
           // next, check just right
           if (ir_ne < IR_NE_TH)
           {
               vRot = 0; vTrans = 0;
               ER1.WANDER_STATE = ER1.BACKUP;
               double randomAngleDelta = 10*(2*Math.random()-1);
               ER1.goalAngle = theta - 90;
               ER1.goalAngle += randomAngleDelta;
               ER1.nextVRot = -20;
               if (realRobot())
               {
               	    double dx = -CS5App.envMap.MAP_OFFSET_X + x + Math.cos(-theta + .52) * ir_ne;
               		double dy = -CS5App.envMap.MAP_OFFSET_Y + y + Math.sin(-theta + .52) * ir_ne;
               		Line2D.Double l = CS5App.envMap.makeWall(dx, dy, dx + 5, dy + 5);
               		//CS5App.envMap.addWall(l);
               		ER1.nextVRot = 20;
               }
               ER1.stateTick = 0; 
               updateParticles();
               return;          
           }
       }
       else if (ER1.WANDER_STATE == ER1.BACKUP)
       {
           H.pl("Backup state  goalAngle = " + ER1.goalAngle);
           stateTick++;   
           if (ER1.stateTick < 5)
           {
               ;
           }
           else if (ER1.stateTick <10)
           {
               vTrans = -10;
           }
           else
           {
               ER1.WANDER_STATE = ER1.DOTURN;
               vRot = ER1.nextVRot;
               if(vRot == 0) vRot = 20;
               stateTick = 0;
           }
           // this is the same as if there were
           // something in front of the N ir, 
           // except no obstacle is seen...   
       }
       else if (ER1.WANDER_STATE == ER1.DOTURN)
       {
           H.pl("Doturn state with vRot = " + vRot + " goalAngle = " + ER1.goalAngle);
           vTrans = 0;
           vRot = ER1.nextVRot;
           if(vRot == 0) vRot = 20;
           if (angleDiff(theta, goalAngle) < 7)
           {
               vTrans = 10;
               vRot = 0;
               ER1.WANDER_STATE = ER1.WANDER;
           }
       }
       else if (ER1.WANDER_STATE == ER1.TURNAROUND)
       {
           H.pl("Turnaround state");
           vTrans = 0;
           if (angleDiff(theta, goalAngle) < 7)
           {
               vRot = 0; vTrans = 0;
               ER1.WANDER_STATE = ER1.DOTURN;
               double randomAngleDelta = 10*(2*Math.random()-1);
               ER1.goalAngle = randomAngleDelta < 0 ? theta + 180 : theta - 180;
               ER1.goalAngle += randomAngleDelta;
               ER1.nextVRot = randomAngleDelta < 0 ? -20 : 20;
               ER1.stateTick = 0;
               return;
           }
       }
	   return;   
	}
	
	public void threadUpdate()
    {
        doPath(IN_PROGRAM); // sets velocities handles WANDER
        
    	if (realRobot())
    	{
    		String s = "A"; // All data
    		// see if the velocity changed
    		if (vTrans != vTransOld || vRot != vRotOld)
    		{
    			s = getGoString(ER1.ALL_DIRS);
    			vTransOld = vTrans; vRotOld = vRot;
    		}
	    	// H.pl("Sending: " + s);
	    	String ret = exchangeWithServer(s);
	    	//H.pl("the returned string is " + s);
	    	String[] L = ret.split("\\s+");
	    	double[] Lvals = new double[L.length];
	    	//H.pl("The split strings (and values) are");
	    	for (int i=1 ; i<L.length ; ++i) // first is "Message: "
	    	{
	    		Lvals[i] = Double.parseDouble(L[i]);
	    		//H.pl("i="+ i + "  " + L[i] + "  " + Lvals[i]);
	    	}
	    	
	    	x = Lvals[1];
	    	y = -Lvals[2];
	    	theta = -Math.toDegrees(Lvals[3]);
	    	time = Lvals[4];
	    	
	    	ir_nw = Lvals[5];
	    	ir_n = Lvals[6];
	    	ir_ne = Lvals[7];
	    		    	
		}
		else // simulated robot
		{

			// get time difference and move the robot
			// according to its velocities
			double timestep = CS5App.myupdater.sleepTime/1000.0; // in seconds
			double vRotUsable = vRot/100.0;
			
			double middleTheta = Math.toRadians(theta) + timestep * vRotUsable / 2.0;
			// middleTheta is the angle we're heading (in radians)
			
			x += timestep * Math.cos(middleTheta) * vTrans; // vTrans in cm/sec
			y += timestep * Math.sin(middleTheta) * vTrans; // vTrans in cm/sec
			theta += timestep * Math.toDegrees(vRotUsable);  // vRot in rad/sec
			time += timestep;
			
			//ir_nw = 50; //(20 + 100*Math.random());
			//ir_n = (20 + 100*Math.random());
			//ir_ne = 50; //(20 + 100*Math.random());
			
			double alpha = Math.atan2(10,40);
			double irt = Math.toRadians(theta), irx = x+41.23*Math.cos(irt+alpha), iry = y+41.23*Math.sin(irt+alpha); 
			ir_ne = Geo.distToNearestWall(irx,iry,irt+0.52);  // change
			
			irx = x+40.0*Math.cos(irt); iry = y+40.0*Math.sin(irt); 
			ir_n = Geo.distToNearestWall(irx,iry,irt);
			
			irx = x+41.23*Math.cos(irt-alpha); iry = y+41.23*Math.sin(irt-alpha); 
			ir_nw = Geo.distToNearestWall(irx,iry,irt-0.52);  // change
			
			wi = CS5App.envMap.getWiSig(x, y);
		}	   
		
		CS5App.cpanel.xEnc.setText(""+(float)x);
    	CS5App.cpanel.yEnc.setText(""+(float)y);
    	CS5App.cpanel.thetaEnc.setText(""+(float)theta);
    	CS5App.cpanel.time.setText(""+(float)time);
    	
    	CS5App.cpanel.ir_nw.setText(""+(float)ir_nw);
    	CS5App.cpanel.ir_n.setText(""+(float)ir_n);
    	CS5App.cpanel.ir_ne.setText(""+(float)ir_ne); 	
    	
    	CS5App.cpanel.vTrans.setText(""+(float)vTrans);
    	CS5App.cpanel.vRot.setText(""+(float)vRot);
    	
    	// do we want to update the particles?
    	if(++updateCounter%updateInterval == 0)
    	{
    	   updateParticles();
    	} 	
    }
	
	public void serverTalk()
	{
		// this probably needs to be run from another thread
		if (!realRobot())
		{
			H.pl("The robot is simulated; there is no server to talk to");
			return;
		}
		
		H.pl("This would be code to talk to the server...");
		
		if (MyClient == null || input == null || output == null)
		{
			H.pl("A connection variable was null. Returning...");
			return;
		}
		
		try
		{
   			String s;
   			
   			while (true)
			{
				H.p("What string would you like to send?  ");
				s = H.nl();
				if (s.equals("quit"))  // "quit" gets out w/o stopping the server
				{
					break; // break out of the while loop
				}
				output.print(s);    // don't use println: it messes with the server			
				H.pl("We sent the string   " + s);
				s = input.readLine();
				if (s == null) continue;  // no line of text available
				H.pl("The string returned from the server was    " + s);
			}
			simulationStatus = ER1.REALROBOT;
   		}
   		catch (Exception e)
		{
			e.printStackTrace();
			this.shutDown();
			simulationStatus = ER1.SIMULATED;
		}	
		
		
	}
	
	public boolean realRobot()
	{
		return this.simulationStatus == ER1.REALROBOT;
	}
	
	public void setVTrans(double vt)
	{
		vTrans = vt;
	}
	
	public void setVRot(double vr)
	{
		vRot = vr;
	}
	
	public void updateFromRobot()
	{
		;
	}
	
	public void handleResizeEvent()
	{
		;
	}
	
	public void handleForward()
    {
    	/*
    	if (realRobot())
    	{
	    	String s = getGoString(ER1.FORWARD);
	    	H.pl("Sending: " + s);
	    	exchangeWithServer(s);
	    }
	    else
	    {*/
	    	vTrans += 10.0; // 10 cm/sec faster
	    	
	    //}	
    }
    
    public void handleBackward()
    {
    	//CS5App.er1.handleBackward();
    	/*
    	String s = CS5App.er1.getGoString(ER1.BACKWARD);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    	
    	/*
    	if (realRobot())
    	{
	    	String s = getGoString(ER1.BACKWARD);
	    	H.pl("Sending: " + s);
	    	exchangeWithServer(s);
	    }
	    else
	    {
	    	*/
	    	vTrans -= 10.0; // 10 cm/sec faster
	    //}
    }
    
    public void handleLeft()
    {
    	//CS5App.er1.handleLeft();
    	/*
    	String s = CS5App.er1.getGoString(ER1.LEFT);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    	/*
    	if (realRobot())
    	{
	    	String s = getGoString(ER1.LEFT);
	    	H.pl("Sending: " + s);
	    	exchangeWithServer(s);
	    }
	    else
	    { */
	    	vRot -= 10.0; // 10 cm/sec faster
	    //}
    }
    
    public void handleRight()
    {
    	//CS5App.er1.handleRight();
    	/*
    	String s = CS5App.er1.getGoString(ER1.RIGHT);
    	H.pl("Sending: " + s);
    	CS5App.er1.exchangeWithServer(s);
    	*/
    	/*
    	if (realRobot())
    	{
	    	String s = getGoString(ER1.RIGHT);
	    	H.pl("Sending: " + s);
	    	exchangeWithServer(s);
	    }
	    else
	    {*/
	    	vRot += 10.0; // 10 cm/sec faster
	    //}
    }
	
    public void handleStop()
	{
		/*
		if (realRobot())
		{
			H.pl("Sending: z");
			exchangeWithServer("z");
			vTrans = 0.0;
			vRot = 0.0;
		}
		else
		{
			*/
			
			vTrans = 0.0;
			vRot = 0.0;
			
		//}
	}
	
	public void updateParticles()
	{
		if (realRobot())
		{
			// update wireless signal strength by reading from the network file
	    	int read = 0;
			char[] cbuf = {'a', 'b'};
    		try {
				fstream = new FileReader(file);
				}
			catch ( FileNotFoundException e ) 
			{
				H.pl("File not found: " + file);
        		e.printStackTrace();
			}
	    	try 
	    	{
	    		//H.pl("available: " + fstream.available());
	    		//fstream.reset();
	    		read = fstream.read(cbuf, 0, 2);
	    		fstream.close();
	    	}
	    	catch (IOException e)
	    	{
	    		H.pl("Problem reading from file!");
        		e.printStackTrace();
	    	}
	    	
	    	//H.pl("read: " + read + " " + cbuf[0] + cbuf[1]);
	    	if (read >= 0)
	    	{
	    		String temp = new String(cbuf);
	    		wi = (Double.valueOf(temp)).doubleValue();
	    	}
		}
		if (pfilter != null)
		{
			if (lastUpdatedPose == null) lastUpdatedPose = new Pose(0.0,0.0,0.0,0.0);
		
		    double current_theta_in_rad = Math.toRadians(theta);
		    
		    double dx = x - lastUpdatedPose.x;
		    double dy = y - lastUpdatedPose.y;
		    double dist = Math.sqrt(dx*dx+dy*dy);
		    // find angle traveled
		    double actual_th = Math.atan2(dy,dx);
		    double dth1 = Math.atan2(dy,dx) - lastUpdatedPose.theta;
		    // find angle moved afterward
		    double dth2 = current_theta_in_rad - actual_th;
		    pfilter.updateWithMotionModel(dth1,dist,dth2);
		    
			lastUpdatedPose.x = x;
			lastUpdatedPose.y = y;
			lastUpdatedPose.theta = current_theta_in_rad;
			
			// that _should_ handle the motion model from the lastUpdatedPose
			
			//H.pl("Do you want to correct? "); H.nl();
			correctParticles();
			
        }
        CS5App.map.repaint();
	}
	
	public void correctParticles()
	{
		if (pfilter != null)
		{
			// remember that the last-sensed values are in
			// ir_nw, ir_n, ir_ne, wi
			
			// goal is to weight each particle
			// to do this, we send the sensor values to
			// the PFilter class and it will adjust probabilities
			
			pfilter.updateWithSensorValues(ir_nw,ir_n,ir_ne,wi);
		}
        CS5App.map.repaint();
	}

	
	public void nextDisplay()
	{
		sensorDisplay = (sensorDisplay+1)%SD_MAX;
		H.pl("Setting next sensor display level");
	}
	
	public void draw(Graphics2D g)
	{
		savedAT = g.getTransform();

    	AT.setToIdentity();
    	AT.translate(x,y);
    	AT.rotate(Math.toRadians(theta));
    	//AT.translate(-w/2,-h/2);
    	g.transform(AT);
    	
    	g.setColor(Color.gray);
        //g.fill(polygon);
        er1poly.draw(g);
        //H.pl("square drawn");
        g.setTransform(savedAT);
        // draw in global coordinates
        pfilter.draw(g);
	}	
}
	