import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.Vector;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;

class MyPanel extends JPanel implements Updatable
{
	public AffineTransform currentAT;
	public AffineTransform savedAT;
    public Vector drawableList;
    
    public double zoom = 1.0;
    public double deltaX = 0.0;
    public double deltaY = 0.0;
    public double theta;
    
    public int currentHeight;
    public int currentWidth;
    
    /* see the URL
     * java.sun.com/products/jfc/tsc/articles/painting/index.html
     * for a complete explanation of what this is doing
     */
    protected void paintComponent(Graphics g)
    {
        super.paintComponent(g);
        drawList((Graphics2D)g);
    }
    
    public void threadUpdate()
    {
    	this.repaint();
    }
    
    public void drawList(Graphics2D g)
    {
        // draw everything in the component!
        // all drawables are in world coordinates, not
        // pixel coordinates...
        currentHeight = this.getHeight();
        currentWidth = this.getWidth(); 
        savedAT = g.getTransform();
        currentAT.translate(deltaX+currentWidth/2,deltaY+currentHeight/2); // center
        AffineTransform AT = AffineTransform.getScaleInstance(zoom,zoom);
        g.transform(currentAT);
        g.transform(AT);

        int listlen = drawableList.size();
        for (int i=0 ; i<listlen ; ++i)
        {
        	Drawable d = (Drawable)(drawableList.get(i));
        	d.draw(g);	
        }
        currentAT.setToIdentity();
        g.setTransform(savedAT);
    }
    
    public MyPanel()
    {
    	super();
    	currentAT = new AffineTransform();
    	drawableList = new Vector();
    	currentHeight = super.getHeight();
        currentWidth = super.getWidth();    
    }
    
    public void addDrawable(Drawable d)
    {
    	drawableList.add(d);
    }
    
    public void resizeHandler()
    {
        //if (m_canvas == null) return;  // nothing's there yet!
        
        //H.pl("The window has been resized... adjusting...");  
        currentHeight = this.getHeight();
        currentWidth = this.getWidth();      
        
        int listlen = drawableList.size();
        
        for (int i=0 ; i<listlen ; ++i)
        {
            Drawable d = (Drawable)(drawableList.get(i));
            d.handleResizeEvent();
        }
        
        // this will affect the transformation, perhaps?!
        // redraw will be handled by Swing
    }
}
	