import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.util.LinkedList;
import javax.swing.*;
import java.io.FileReader;
import java.io.BufferedReader;
import java.io.StreamTokenizer;
import H.*;


class MyPoly implements Drawable
{
    public float cx,cy,w,h,theta;
    public AffineTransform AT;
    public GeneralPath polygon;
    public Line2D.Double ir_nw;
    public Line2D.Double ir_n;
    public Line2D.Double ir_ne;
    public Line2D.Double cam;
    
    public MyPoly()
    {
    	AT = null;
        this.cx = 0;
        this.cy = 0;
        this.w = 40;
        this.h = 60;  // not used right now
        this.theta = 0;
        
        // all in centimeters
        polygon = new GeneralPath();
        polygon.moveTo(-9,-19);
        polygon.lineTo(24,-19);
        polygon.lineTo(40,0);
        //polygon.lineTo(40,-10);
        //polygon.lineTo(40,10);
        polygon.lineTo(24,19);
        polygon.lineTo(-9,19);
        polygon.closePath();
        
        ir_nw = new Line2D.Double();
        ir_n = new Line2D.Double();
        ir_ne = new Line2D.Double();
        cam = new Line2D.Double();
    }
    
    public void draw(Graphics2D g) // uses sensor display level
    {
    	//AffineTransform savedAT = g.getTransform();
    	
    	//AT = new AffineTransform();
    	//AT.rotate(Math.toRadians(theta));

    	//g.transform(AT);
    	
    	//g.setColor(Color.red);
        g.fill(polygon);

		int sd = CS5App.er1.sensorDisplay;
        if (sd == ER1.SD_NONE) return;
        
        double nw_x2 = 40+Math.cos(0-0.52)*(CS5App.er1.ir_nw);
        double nw_y2 = Math.sin(0-0.52)*(CS5App.er1.ir_nw)-10;
        
        double ne_x2 = 40+Math.cos(0.52)*(CS5App.er1.ir_ne);
        double ne_y2 = Math.sin(0.52)*(CS5App.er1.ir_ne)+10;
        
        ir_nw.setLine(40,-10,nw_x2,nw_y2); // could include an angle, too...
        ir_n.setLine(40,0,40+CS5App.er1.ir_n,0);
        ir_ne.setLine(40,10,ne_x2, ne_y2);
        
        //ir_nw.setLine(40,-10,40+CS5App.er1.ir_nw,-10); // could include an angle, too...
        //ir_n.setLine(40,0,40+CS5App.er1.ir_n,0);
        //ir_ne.setLine(40,10,40+CS5App.er1.ir_ne,+10);
        cam.setLine(18,0,18,50);
        
        if (sd == ER1.SD_IR || sd == ER1.SD_IR_CAM)
        {
        	g.setColor(Color.orange);
        	g.draw(ir_nw);
        	g.draw(ir_n);
        	g.draw(ir_ne);
        }
        
        if (sd == ER1.SD_CAM || sd == ER1.SD_IR_CAM)
        {
        	g.setColor(Color.red);
        	g.draw(cam);
        }

        //g.setTransform(savedAT);
    }
    
    public void nextStep()
    {
    	;
    }
    
    public void handleResizeEvent()
    {
    	;
    }
}
	